<?php

use CRM_Updaterecur_ExtensionUtil as E;

return [
  [
    'name' => 'SavedSearch_Recurring_Contribution_Changes_Monitor',
    'entity' => 'SavedSearch',
    'cleanup' => 'always',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Recurring_Contribution_Changes_Monitor',
        'label' => E::ts('Monitor Recurring Contribution changes'),
        'api_entity' => 'Activity',
        'api_params' => [
          'version' => 4,
          'select' => [
            'activity_date_time',
            'status_id:label',
            'subject',
            'id',
            'updaterecur_activity_fields.updaterecur_new_amount',
            'updaterecur_activity_fields.updaterecur_old_amount',
            'Activity_ActivityContact_Contact_01.display_name',
            'updaterecur_activity_fields.updaterecur_recur_id',
          ],
          'orderBy' => [],
          'where' => [
            [
              'activity_type_id:name',
              '=',
              'updaterecur_change',
            ],
          ],
          'groupBy' => [],
          'join' => [
            [
              'Contact AS Activity_ActivityContact_Contact_01',
              'LEFT',
              'ActivityContact',
              [
                'id',
                '=',
                'Activity_ActivityContact_Contact_01.activity_id',
              ],
              [
                'Activity_ActivityContact_Contact_01.record_type_id:name',
                '=',
                '"Activity Targets"',
              ],
            ],
          ],
          'having' => [],
        ],
      ],
      'match' => [
        'name',
      ],
    ],
  ],
  [
    'name' => 'SavedSearch_Recurring_Contribution_Changes_Monitor_SearchDisplay_Table',
    'entity' => 'SearchDisplay',
    'cleanup' => 'always',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Table',
        'label' => E::ts('Table'),
        'saved_search_id.name' => 'Recurring_Contribution_Changes_Monitor',
        'type' => 'table',
        'settings' => [
          'actions' => TRUE,
          'limit' => 50,
          'classes' => [
            'table',
            'table-striped',
          ],
          'pager' => [
            'show_count' => TRUE,
            'expose_limit' => TRUE,
          ],
          'sort' => [],
          'columns' => [
            [
              'type' => 'field',
              'key' => 'activity_date_time',
              'dataType' => 'Timestamp',
              'label' => E::ts('Date'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'status_id:label',
              'dataType' => 'Integer',
              'label' => E::ts('Status'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'subject',
              'dataType' => 'String',
              'label' => E::ts('Reason'),
              'sortable' => TRUE,
              'title' => E::ts("The reason for the change is stored as the activity's subject"),
            ],
            [
              'type' => 'field',
              'key' => 'Activity_ActivityContact_Contact_01.display_name',
              'dataType' => 'String',
              'label' => E::ts('Contact'),
              'sortable' => TRUE,
              'link' => [
                'path' => '',
                'entity' => 'Contact',
                'action' => 'view',
                'join' => 'Activity_ActivityContact_Contact_01',
                'target' => '_blank',
              ],
              'title' => E::ts('View Contact'),
            ],
            [
              'type' => 'field',
              'key' => 'updaterecur_activity_fields.updaterecur_new_amount',
              'dataType' => 'Float',
              'label' => E::ts('Amount'),
              'sortable' => FALSE,
              'rewrite' => '[updaterecur_activity_fields.updaterecur_old_amount] → [updaterecur_activity_fields.updaterecur_new_amount]',
            ],
            [
              'links' => [
                [
                  'entity' => '',
                  'action' => '',
                  'join' => '',
                  'target' => 'crm-popup',
                  'icon' => 'fa-money',
                  'text' => E::ts('View Recurring'),
                  'style' => 'default',
                  'path' => 'civicrm/contact/view/contributionrecur?reset=1&id=[updaterecur_activity_fields.updaterecur_recur_id]&cid=[Activity_ActivityContact_Contact_01.id]',
                  'condition' => [],
                  'task' => '',
                ],
                [
                  'path' => 'civicrm/activity?reset=1&action=view&id=[id]&cid=[Activity_ActivityContact_Contact_01.id]',
                  'icon' => 'fa-list-alt',
                  'text' => E::ts('View Activity'),
                  'style' => 'default',
                  'condition' => [],
                  'task' => '',
                  'entity' => '',
                  'action' => '',
                  'join' => '',
                  'target' => 'crm-popup',
                ],
              ],
              'type' => 'links',
              'alignment' => 'text-right',
            ],
          ],
          'cssRules' => [
            [
              'bg-danger',
              'status_id:label',
              '=',
              'Cancelled',
            ],
            [
              'bg-success',
              'status_id:label',
              '=',
              'Completed',
            ],
          ],
          'placeholder' => 5,
        ],
      ],
      'match' => [
        'saved_search_id',
        'name',
      ],
    ],
  ],
];