<?php

use CRM_Updaterecur_ExtensionUtil as E;

return [
  [
    'name' => 'SavedSearch_Upgrade_Recurring_Contributions',
    'entity' => 'SavedSearch',
    'cleanup' => 'always',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Upgrade_Recurring_Contributions',
        'label' => E::ts('Find Recurring Contributions to change'),
        'api_entity' => 'ContributionRecur',
        'api_params' => [
          'version' => 4,
          'select' => [
            'id',
            'ContributionRecur_Contact_contact_id_01.display_name',
            'financial_type_id:label',
            'payment_instrument_id:label',
            'amount',
            'is_test',
            'payment_processor_id:label',
          ],
          'orderBy' => [],
          'where' => [],
          'groupBy' => [],
          'join' => [
            [
              'Contact AS ContributionRecur_Contact_contact_id_01',
              'LEFT',
              [
                'contact_id',
                '=',
                'ContributionRecur_Contact_contact_id_01.id',
              ],
            ],
          ],
          'having' => [],
        ],
      ],
      'match' => [
        'name',
      ],
    ],
  ],
  [
    'name' => 'SavedSearch_Upgrade_Recurring_Contributions_SearchDisplay_Table',
    'entity' => 'SearchDisplay',
    'cleanup' => 'always',
    'update' => 'unmodified',
    'params' => [
      'version' => 4,
      'values' => [
        'name' => 'Table',
        'label' => E::ts('Table'),
        'saved_search_id.name' => 'Upgrade_Recurring_Contributions',
        'type' => 'table',
        'settings' => [
          'actions' => [
            'updaterecur_change_subscriptions_task',
            'download',
          ],
          'limit' => 50,
          'classes' => [
            'table',
            'table-striped',
          ],
          'pager' => [
            'show_count' => TRUE,
            'expose_limit' => TRUE,
          ],
          'sort' => [],
          'columns' => [
            [
              'type' => 'field',
              'key' => 'id',
              'dataType' => 'Integer',
              'label' => E::ts('Recur ID'),
              'sortable' => TRUE,
              'alignment' => 'text-right',
            ],
            [
              'type' => 'field',
              'key' => 'ContributionRecur_Contact_contact_id_01.display_name',
              'dataType' => 'String',
              'label' => E::ts('Contact'),
              'sortable' => TRUE,
              'link' => [
                'path' => '',
                'entity' => 'Contact',
                'action' => 'view',
                'join' => 'ContributionRecur_Contact_contact_id_01',
                'target' => '_blank',
              ],
              'title' => E::ts('View Recurring Contribution Contact'),
            ],
            [
              'type' => 'field',
              'key' => 'financial_type_id:label',
              'dataType' => 'Integer',
              'label' => E::ts('Financial Type'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'payment_processor_id:label',
              'dataType' => 'Integer',
              'label' => E::ts('Payment Processor'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'payment_instrument_id:label',
              'dataType' => 'Integer',
              'label' => E::ts('Payment Method'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'amount',
              'dataType' => 'Money',
              'label' => E::ts('Amount'),
              'sortable' => TRUE,
            ],
            [
              'type' => 'field',
              'key' => 'is_test',
              'dataType' => 'Boolean',
              'label' => E::ts('Test'),
              'sortable' => TRUE,
            ],
          ],
          'button' => NULL,
          'placeholder' => 5,
          'headerCount' => TRUE,
        ],
      ],
      'match' => [
        'saved_search_id',
        'name',
      ],
    ],
  ],
];
